<?php

    use Illuminate\Database\Migrations\Migration;
    use Illuminate\Database\Schema\Blueprint;
    use Illuminate\Support\Facades\Schema;
    use Modules\Lpj\Models\Branch;

    return new class extends Migration {
        /**
         * Run the migrations.
         */
        public function up()
        : void
        {
            Schema::create('debitures', function (Blueprint $table) {
                $table->id();
                $table->foreignIdFor(Branch::class)->constrained()->onDelete('cascade');
                $table->string('cif', 10)->unique();
                $table->string('name');
                $table->date('registered_at')->nullable();
                $table->string('npwp', 16)->nullable();
                $table->string('nomor_id', 16)->nullable();
                $table->string('email', 100)->nullable();
                $table->string('phone', 15)->nullable();
                $table->string('nomor_rekening', 50)->nullable();
                $table->string('province_code')->nullable()->index();
                $table->string('city_code')->nullable()->index();
                $table->string('district_code')->nullable()->index();
                $table->string('village_code')->nullable()->index();
                $table->string('postal_code', 5)->nullable();
                $table->text('address')->nullable();

                $table->boolean('status')->default(true)->nullable();
                $table->timestamps();
                $table->timestamp('authorized_at')->nullable();
                $table->char('authorized_status', 1)->nullable();
                $table->softDeletes();

                $table->unsignedBigInteger('created_by')->nullable();
                $table->unsignedBigInteger('updated_by')->nullable();
                $table->unsignedBigInteger('deleted_by')->nullable();
                $table->unsignedBigInteger('authorized_by')->nullable();
            });
        }

        /**
         * Reverse the migrations.
         */
        public function down()
        : void
        {
            Schema::dropIfExists('debitures');
        }
    };
